__author__ = 'Epirasque'
import sys
from math import *
import matplotlib.pyplot as plt

original_costs = \
    0, 50, 80, 150, 200, 250, 300, 400, 600, 650, 800, 900, \
    1150, 1500, 2000, 2750, 3150, 3500, 3750, 4500, 5000, 6000, 6500, 7500, \
    10000, 12500, 13500, 15000, 20000, 25000, 35000

# --- define your custom function here, it is active by default in the main method below ---
def custom(original_cost):
    return original_cost

def exp_increase(original_cost):
    return pow(original_cost, 1.05)

def exp_decrease(original_cost):
    return pow(original_cost, 0.95)

def sigmoid(original_cost):
    return 24940 - 1 / (0.00004 + pow(original_cost + 2000, 4) * 0.00000000000000000001)

def aesthetic_round(value_to_round):
    rounded_value = value_to_round
    if value_to_round > 10000:
        rounded_value = round(value_to_round/1000)*1000
    elif value_to_round > 1000:
        rounded_value = round(value_to_round/50)*50
    else:
        rounded_value = round(value_to_round / 10) * 10
    return rounded_value

def main(argv):
    # --- chose which function to use by commenting in the correct line ---
    #COST_FUNCTION_TO_USE = exp_increase
    #COST_FUNCTION_TO_USE = exp_decrease
    #COST_FUNCTION_TO_USE = sigmoid
    COST_FUNCTION_TO_USE = custom

    function_name = str(COST_FUNCTION_TO_USE.__name__)
    print("\n\ncost_map_" + function_name + " = {")

    new_costs = []
    for i, original_cost in enumerate(original_costs, start = 1):
        if original_cost == 0:
            new_costs.append(0)
        else:
            new_costs.append(aesthetic_round(round(COST_FUNCTION_TO_USE(original_cost))))
        output = '\t[%u] = %u' % (original_cost, new_costs[-1])
        if i != len(original_costs):
            output = output + ','
        print(output)
    print("}\n\n")

    x = original_costs
    y = new_costs
    plt.title(function_name)
    plt.scatter(x, y)
    plt.plot(x, y)
    plt.show()

if __name__ == "__main__":
    main(sys.argv)
